
Global wastehall = 0; ! Set in end_scene if the player wasted a blip in the hall
Global wasteroom = 0; ! Ditto, in a room. (Both count number of wasted blips.)
Global wasteentry = 0; ! Set 1 at entry if scrambler is active.

Object sc_5
  class Scene,
  with
	number 5,
	init_scene [;
		SetQuestion(q5_1);
	],
	begin_scene [ rock;
		wastehall = 0;
		wasteroom = 0;
		wasteentry = 0;
		give SecurityOffice ~general;
		OfficeSketchStartup();
		move poisonpen to storetable;
		move pennib to poisonpen;
		securityscanners.startup();
		switch (rock) {
			1: ! first time in
				move activeplayer to SecurityAnnex; 
				give SecurityBranch ~visited; ! in case we saw it in scene 3
				if (scrambler has general)
					wasteentry = 1;
				SaveToolPositions();
			2, -1, -2: ! all subsequent times (including boom/splat)
				move activeplayer to SecurityAnnex; 
				RestoreToolPositions();
				if (scrambler has general) {
					print "     --   . []^";
				}
		}
	],
	end_scene [ rock subrock;
		securityscanners.shutdown();
		switch (rock) {
			-1:
				SetAcidQuestions(subrock);
			-2:
				SetBlastQuestions(subrock);
			-3: ! security door open
				" ,   . --! []";
			-4: ! pen suicide
				if (q5_dp1 hasnt general) {
					give q5_dp1 general;
					SetQuestion(q5_dp1);
				}
				else {
					SetQuestion(q5_dp1r);
				}
			1: ! walked over threshold without horking.
				if (q5_d1 hasnt general) {
					give q5_d1 general;
					SetQuestion(q5_d1, subrock);
				}
				else {
					SetQuestion(q5_d1r, subrock);
				}
			2: ! horker on too long.
				if (q5_d2 hasnt general) {
					give q5_d2 general;
					SetQuestion(q5_d2);
				}
				else {
					SetQuestion(q5_d2r);
				}
			3: ! not exactly 4 blips
				if (q5_d3 hasnt general) {
					give q5_d3 general;
					SetQuestion(q5_d3, subrock);
				}
				else {
					SetQuestion(q5_d3r, subrock);
				}
			4: ! entered zero or one rooms
				SetQuestion(q5_d4, subrock);
			5: ! left with scrambler on
				SetQuestion(q5_d5);
			6: ! seen in interrog room
				if (q5_d6 hasnt general) {
					give q5_d6 general;
					SetQuestion(q5_d6);
				}
				else if (q5_d6r hasnt general) {
					give q5_d6r general;
					SetQuestion(q5_d6r);
				}
				else {
					SetQuestion(q5_d6rr);
				}
			7: ! left pen behind
				if (q5_d7 hasnt general) {
					give q5_d7 general;
					move poisonpen_model to Himself;
					SetQuestion(q5_d7, subrock);
				}
				else {
					SetQuestion(q5_d7r, subrock);
				}
			8: ! left tools behind
				SetQuestion(q5_d8, subrock);
			9: ! diddled reamer controls
				SetQuestion(q5_d9);
			20: ! success
				SetScene(sc_6);
		}
	];

! Emotional status to date: (absolute strained maximums)
! Minimum: 7 helpful, 5 cosmos, nothing else.
! Maximum: 4 blatant lies, 4 sneaky lies, 9 stubborns, 6 angries, 4 stupid,
!   6 jingos, 3 dumb recall.
! (That's not counting acid/blast queries, which are 1 sneaky, 3 blatant,
! 3 stubborn, 1 angry; or 1 helpful.)
! In startup: +3 stupids, +1 cosmos, +1 jingos, +2 stubborns, +1 blatant.

Object q5_1
  class Question,
  with
	query [;
		print "^@<<";
		if (q4_db1 hasnt general) {
			print " ,      ?    ,    .      .";
		}
		else {
			print "    .   .";
		}
		print "      .   ,     @>>.^^      . @<< ,     @>>.^";
		rtrue;
	],
	time_limit 4,
	answer_yes [;
		num_cosmos++;
		if (num_cosmos > num_jingos)
			print "  . @<<, ";
		else
			print "@<<   . ";
		print "    ,     .  :   ,    ?";
		SetQuestion(q5_2);
	],
	answer_no [;
		num_stupids++;
		if (num_cosmos > num_jingos)
			print "@<<  ?  ";
		else
			print "@<<,     . ";
		print "  ,    ?";
		SetQuestion(q5_2);
	],
	answer_wait [;
		print "@<<:   ,    ?";
		SetQuestion(q5_2);
	];

Object q5_2
  class Question,
  with
	query "      ,    @>>.",
	time_limit 6,
	answer_yes [;
		num_stupids++;
		print "  . @<<    ,     @>>.^^   .";
		SetQuestion(q5_3);
	],
	answer_no [;
		num_stupids++;
		self.answer_yes();
	],
	answer_wait [;
		num_stubborns++;
		print "        . @<<  --      @>>.^^   .";
		SetQuestion(q5_3);
	];

Object q5_3
  class Question,
  with
	query [;
		print " @<< .";
		if (q4_3.number2 == 'yes')
			print "     .";
		else
			print "  ,      .";
		print "         .         ,   .       ...@>>      .^^@<< ,     .       ,     .   ?      ?@>>^";
		rtrue;
	],
	time_limit 3,
	answer_yes [;
		num_jingos++;
		print "@<< ... .  ";
		SetQuestion(q5_4);
	],
	answer_no [;
		print "@<< ... .  ";
		SetQuestion(q5_4);
	],
	answer_wait [;
		num_stupids++;
		print "@<< ,     , ... .  ";
		SetQuestion(q5_4);
	];

Object q5_4
  class Question,
  with
	query "@>>.     .^^
		@<<   ,    .     .        ?@>>        --  ,      .",
	time_limit 3,
	answer_yes [;
		print "@<<,  ,    .  @>>.^";
		BeginScene(1);
	],
	answer_no [;
		num_blatant_lies++;
		print "@<<     ,   ,    ,     .  @>>.^";
		BeginScene(1);
	],
	answer_wait [;
		num_stubborns++;
		print "@<<     ,   ,    ,     .  @>>.^";
		BeginScene(1);
	];

Object q5_d1
  class Question,
  with
	query [;
		if (self.variant == 2)
			print "^@<<   ,               .";
		else
			print "^@<< ,     ,       .";
		if (num_stupids + 2*num_dumb_recall >= 4)
			print "        ,    ,    ";
		else
			print "    ,     ";
		print "@>>.^";
		num_dumb_recall++;
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q5_d1r
  class Question,
  with
	query [;
		if (self.variant == 2)
			print "^@<<  ,    ,     ,        . ?@>>     .^";
		else
			print "^  . @<<,    ,   .    ,  @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q5_d2
  class Question,
  with
	query [;
		print "^@<<,   . ";
		if (q2_d3 has general)
			print ",    ,";
		print "     .       ,      . , ?      ,      .    ,   @>>.   . @<<";
		if (wasteentry == 0)
			print " ,       ";
		else
			print "  ,          .      ";
		print "@>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q5_d2r
  class Question,
  with
	query [;
		print "^@<<  ,         .  ,    . -,    ,    .     ", (emphstring) "", " @>>.^";
		BeginScene(2);
	];

Object q5_d3
  class Question,
  with
	query [;
		! we know numblips isn't zero, because the player got the pen.
		print "^@<<, --   . --   .";
		if (q2_d3 has general || q5_d2 has general)
			print "    ,";
		else
			print "  ,";
		print "    ,      ,    ,      .     ,   .    :     .   --   , .";
		print "    ,     ";
		if (self.variant < 4)
			print "  ", (EnglishNumber) self.variant;
		else 
			print " ", (EnglishNumber) self.variant;
		if (self.variant % 10 == 2 or 3 or 4 && self.variant ~= 12 or 13 or 14)
			print " ";
		else
			print " ";
		print ", ";
		if (wastehall || wasteroom) {
			print "  ,  ,        .     ,    - ,            ";
		}
		print "@>>.^^  . @<<      ,     ,     @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q5_d3r
  class Question,
  with
	query [;
		print "^@<<   ,  ?   ,     ",
			(EnglishNumber) self.variant, ",    ";
		if (wastehall || wasteroom) {
			print "   ,        ";
		}
		print "@>>.^";
		BeginScene(2);
	];

[ dullroomname obj;
	switch (obj) {
		SecurityOffice: print "  ";
		SecurityStorage: print " ";
		InterrogRoomReal: print "  ";
		default: print "  []";
	}
];

Object q5_d4
  class Question,
  with
	query [;
		! so, not all of this code really gets used (must be storage room)
		print "^@<<.  ,      .";
		if (self.variant == nothing) {
			print "       ,         ";
		}
		else {
			print "         ",
				(dullroomname) self.variant, ".      ,    .";
		}
		print "@>>.^";
		BeginScene(2);
	];

Object q5_d5
  class Question,
  with
	query [;
		print "^@<<,            ,    @>>.^";
		BeginScene(2);
	];	

Object q5_d6
  class Question,
  with
	query [;
		print "^@<<  @>>.  ,  . @<<  , ,      . ";
		if (interrealchair.number >= 6 || interrealchair.number < 0) {
			print "    , ... ...      . ";
			if (interrealchair.number < 0) {
				print "     ,      @>>.  ,    ,  . @<<";
			}
		}
		print "   ?    ,  , , -   , .       ?@>>^";		
		rtrue;
	],
	time_limit 4,
	answer_general [;
		print "  ?@>>   . @<<     ,    ,   --@>>       ,   . @<<  , ...  ...@>>      .^^       . @<< ", 
			(emphstring) "", "...!@>>   ,     ,        .      ,        .^";
		BrainDrain();
	],
	answer_yes [;
		print "@<<, - .";
		self.answer_general();
		rtrue;
	],
	answer_no [;
		num_helpfuls++;
		print "@<<@>>.      . @<<  ,   . . , ,   @>>.^";
		BeginScene(2);
	],
	answer_wait [;
		print "@<<,  ";
		if (num_helpfuls >= 4)
			print "@>>.       .";
		else
			print "@>>, --  .";
		print "^^     . @<<,  ,    .   @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q5_d6r
  class Question,
  with
	query [;
		print "^@<<,     .   ,       . , -,  ,      --  ", (emphstring) "", 
			" .    @>>.   ,       .^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q5_d6rr
  class Question,
  with
	query [;
		print "^@<<  ,   -    .";
		q5_d6.answer_general();
		rtrue;
	],
  has ~general; ! general means it's been asked

Object q5_d7
  class Question,
  with
	query [;
		print "^@<<  ,  ";
		if (self.variant == 1)
			print "   ";
		else
			print ",    ";
		print "?@>>   ";
		if (SecurityStorage has visited)
			print ", ,     ,";
		print "    ,    .^";
		rtrue;
	],
	time_limit 7,
	answer_yes [;
		num_blatant_lies++;
		print "@<<?       -- , ,  @>>.^";
		BeginScene(2);
	],
	answer_no [;
		print "@<<- .          @>>.^";
		BeginScene(2);
	],
	answer_wait [;
		print "   . @<<,  ,  .        -- , ,  @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q5_d7r
  class Question,
  with
	query [;
		print "^@<<,     .";
		print "    ,";
		if (self.variant == 1)
			print "     ";
		else
			print "   ,    ";
		print "@>>.^";
		BeginScene(2);
	];

Object q5_d8
  class Question,
  with
	query [;
		print "^@<<,  ,     .";
		if (self.variant == 1)
			print "    ";
		else
			print "     ", (cGen) self.variant, ",   "; 
		! print " left behind";
		print ".  ,       @>>.^"; 
		BeginScene(2);
	];

Object q5_d9
  class Question,
  with
	query [;
		print "^@<<   ,      ,     .  ", (emphstring) "", "     ,     @>>.^";
		BeginScene(2);
	];

Object q5_dp1
  class Question,
  with
	query "^@<< ,   ,      @>>.   . @<<      .      @>>.",
	time_limit 4,
	answer_yes [;
		print "@<<  @>>.^";
		BeginScene(2);
	],
	answer_no [;
		print "@<<  ? ,  ,       . ,      .     ,     @>>.^";
		BeginScene(2);
	],
	answer_wait [;
		num_stubborns++;
		print "@<<,      ,   ?   @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q5_dp1r
  class Question,
  with
	query [;
		print "^@<<,  ,             @>>.^";
		BeginScene(2);
	];

Object q5_da1
  class Question,
  with
	query [;
		print "^@<<,    .       ,   -   @>>.^";
		BeginScene(2);
	];

Object q5_da2
  class Question,
  with
	query [;
		print "^@<< , --  , --     @>>.     ,  ,   ,       . @<<   @>>.^";
		BeginScene(2);
	];

Object q5_da3
  class Question,
  with
	query [;
		print "^@<< , ,  @>>.   . @<<   ,  ,     .       @>>.     .^";
		BeginScene(2);
	];

! ------------- The scene in security

Object SecurityAnnex "  "
  with
	description "   ,    -    .        ,   .",
	before [   ptr wt;
		if (wasteentry) {
			wasteentry++;
			if (wasteentry >= 3) {
				! disconnect the damn thing
				ptr = scrambler.&data_cache;
				wt = ptr-->1; ! work_target
				ptr-->1 = 0; ! work_target
				ptr-->2 = 0; ! general set false
				if (wt == nothing) {
					print " - . []^";
				}
				else {
					ptr = wt.&data_cache;
					ptr-->1 = 0; ! work_target
					ptr-->0 = toolcase; ! location
				}
				! and end scene
				print ",    ,      .    ,      .^";
				EndScene(2);
				rtrue;
			}
		}
	],
	sw_to [;
		if (escaping) {
			return SecurityBranch;
		}
		PlayerTo(SecurityBranch, 2);
		TryLeaveSecurity();
		rtrue;
	],
	e_to secdooreast,
	n_to secdoornorth,
	s_to secdoorsouth;

[ ScramblerPos    pos;
	pos = locationof(scrambler);
	if (pos == SecurityAnnex)
		return 1;
	if (pos == SecurityOffice)
		return 2;
	if (pos == SecurityStorage)
		return 2;
	if (pos == InterrogRoomReal)
		return 2;
	return 0;
];

Class SecurityDoorway
  with
	name '' '' '' '',
	door_try [;
		if (escaping) {
			if (self.door_dir == n_to && HimselfEscape has general)
				rfalse;
			print "     ,    .^";
			SummonEsguardsSecurity();
			rfalse;
		}
		! else scene 5
		if (scrambler has general && scrambler.fried == 0 && ScramblerPos()) {
			rfalse;
		}
		else {
			securityscanners.number = 1;
			print "     ,   .^";
			rfalse;
		}
	],
	description [;
		self.number2();
		"^ ,  ,     .";
	],
	before [;
		Search: <<Examine self>>;
	],
  has door open scenery;

Class SecurityDoorwayIn
  with
	name '' '' '',
	short_name "",
	description "    .       .",
	door_to SecurityAnnex, ! well, they all do
	door_try [;
		if (escaping) {
			if (self.door_dir == s_to) {
				if (HimselfEscape has general) {
					if (self hasnt general)
						print "      . .     ,      ,   -.^";
					give self general;
				}
				else {
					print "        . ,  ,     ,        .^^    ,    .^"; 
					SummonEsguardsSecurity();
				}
				rfalse;
			}
			else {
				print "     ,    .^";
				SummonEsguardsSecurity();
				rfalse;
			}
		}
		! else scene 5
		if (scrambler has general && scrambler.fried == 0 && ScramblerPos() == 1) {
			rfalse;
		}
		else {
			securityscanners.number = 2;
			print "     ,   .^";
			rfalse;
		}
	],
	before [;
		Search: <<Examine self>>;
	],
  has door open scenery;

Class SecurityRoomsJunk
  with
	number2 " []",
	short_name [;
		print "    ", (string) self.number2;
		rtrue;
	],
	before [;
		default: 
			print_ret "     ", (string) self.number2, ".";
	],
  has scenery pluralname;

Object -> secnodoor "-/ /"
  with
	name '' '-' '-' '' '',
	description "   -  .",
	before [;
		Examine:
			rfalse;
		Search:
			<<Examine self>>;
		Enter:
			<<Go sw_obj>>;
		default:
			"   -.";
	],
  has scenery male;

Object -> secdooreast "/ /"
  class SecurityDoorway,
  with
	name '//' '' '',
	number2 "   :          . ,      .",
	door_to SecurityOffice,
	door_dir e_to,
	has male;

Object -> eastroomjunk
  class SecurityRoomsJunk,
  with
	name '' '',
	number2 "";

Object -> secdoornorth "/ /"
  class SecurityDoorway,
  with
	name '//' '' '',
	number2 [;
		print "     .";
		if (interrealchair in InterrogRoomReal)
			"         ;    .";
		else
			"       ,    .";
	],
	door_to InterrogRoomReal,
	door_dir n_to,
	has male;

Object -> northroomjunk
  class SecurityRoomsJunk,
  with
	name '' '' '' '',
	number2 "";

Object -> secdoorsouth "/ /"
  class SecurityDoorway,
  with
	name '//' '' '',
	number2 "   ,     .",
	door_to SecurityStorage,
	door_dir s_to,
	has male;

Object -> southroomjunk
  class SecurityRoomsJunk,
  with
	name '' '',
	number2 "";

Object -> secdoorbands "/  "
  with
	name '' '' '' '' '',
	description "    ,   ,      .      ,         .",
	before [;
		Examine:
			rfalse;
		default:
			"   .";
	],
  has scenery pluralname;

! remember this can be seen (briefly) from scene 3 and 5. But you can 
! only *be* here when escaping.
Object SecurityBranch "  "
  with
	description [;
		print "     ,       .     -.      ,      .";
		new_line;
		if (powercut) {
			print "^  ,  -,     ;      .^";
		}
		rtrue;
	],
	w_to secbranchdoor,
	ne_to SecurityAnnex,
	n_to NortheastCorner, 
	s_to TossJunction;

Object -> secbranchdoor "/ /"
  class InteriorDoor,
  with
	name '//' '' '' '',
	door_dir w_to,
	before [;
		ActivateTool:
			if (location == SecurityBranch) {
				deadflag = 3;
				"^ ,      . ,   ,         ,       .";
			}
			if (location == NortheastCorner or TossJunction or SecurityAnnex) {
				deadflag = 3;
				print "^  , ";
				switch (location) {
					NortheastCorner: print " ";
					TossJunction: print " ";
					SecurityAnnex: print " -";
				}
				", .   ,  .     , ,  ,    .";
			}
			remove lockpick; ! a guard grabs it
			SummonEsguardsSecurity(1);
			rtrue;
	];

Object -> secbranchdoorplate "/ /  "
  class InteriorPlate,
  with
	work_target secbranchdoor;

Object securityceiling "///"
  with
	name '' '' '' '' '',
	found_in SecurityOffice InterrogRoomReal SecurityStorage,
	description "      .     ,     .        .",
    casegen [ beg end csID;
        return ICVowel (csID, beg, end, '', 0);
	],
	react_before [;
		Examine: 
			rfalse;
		Jump:
			if (player in officedesk)
				" ,        .";
			if (player in interrealchair)
				"   ,   .";
			"    .     ,   ,  - .";
		default:
			if (noun == securitylights or securitylightgrilles) {
				if (player notin officedesk)
					"      30 .";
			}
	],
	before [;
		if (action == ##Examine)
			rfalse;
		if (player notin officedesk)
			"      30 .";
		switch (action) {
			##Push:
				"     - .";
			##Touch, ##Rub:
				"    .";
			##Attack, ##KnockOn:
				"    .";
		}
	],
  has scenery transparent male;

Object -> securityweb "/ /"
  with
	name '' '' '' '' '',
	description "       .     ,         .",
	before [;
		Examine:
			rfalse;
		default:
			if (player in officedesk)
				"     ,  .       .";
			"      30 .";
	],
  has scenery female;

Object -> securitylights "/ /"
  with
	name '' '' '' '' '' '' '' '',
	description "     ,        .",
	before [;
		Examine:
			rfalse;
		default:
			"    .";
	],
  has scenery pluralname;

Object -> securitylightgrilles "/ /"
  with
	name '' '' '',
	description "    .",
	before [;
		Take, Push, Pull, Turn, Open, Attack:
			"    .";
	],
  has scenery pluralname;

Object SecurityOffice "  "
  with
	description [ ix;
		print "     ,       ,    .        .        , ";
		ix = OfficeSketchNumHanging();
		if (ix) {
			print "   ";
			switch (ix) {
				1: print "  ";
				2: print "  ";
				default: print "  ";
			}
			print ", ";
		}
		print "      .";
		new_line;
		ix = OfficeSketchNumLying();
		if (ix) {
			switch (ix) {
				1: print "^   ", (name) (sketchlist-->0), ".^";
				2: print "^    : ", (name) (sketchlist-->0),
					"  ", (name) (sketchlist-->1), ".^";
				3: print "^    : ", (name) (sketchlist-->0),
					", ", (name) (sketchlist-->1),
					"  ", (name) (sketchlist-->2), ".^";
			}
		}
		rtrue;
	],
	out_to secofficedoorway,
	w_to secofficedoorway,
	before [;
		Look, Go, Enter, Exit, VagueGo, Wait, Inv:
			rfalse;
		Tango, Waltz, VagueSay, Answer:
			rfalse;
		ActivateTool, DeactivateTool:
			! fake actions
			rfalse;
		Examine, Search:
			if (noun && anywherein(noun, player)) {
				rfalse;
			}
			give self general;
			rfalse;
		default:
			give self general;
			rfalse;
	],
  has ~general; ! general means you actually did something

Object -> secofficedoorway "/"
  class SecurityDoorwayIn,
  with
	name '//' '' '',
	door_dir w_to,
    has male;

Object -> secofficewalls "/  "
  with
	name '' '' '' '' '' '',
	description "  - , ,          .",
	before [;
		Touch, Rub:
			"    .";
		Attack, KnockOn:
			"   ,     .      .";
		Listen:
			"      --     .";
		Take, Push, Pull:
			"     .";
		Search:
			"         .    ,     .";
		Smell, Taste:
			"      -  .";
	],
  has scenery pluralname;

Object -> officecabinets "/"
  with
	name '' '' '',
	description [;
		print "      ,     .       ,        .";
		if (self has open)
			"    .";
		else
			"   .";
	],
	before [;
		Open:
			"    ,  ,    .";
		Close:
			if (self hasnt open)
				"   .";
		Push, Pull, Turn:
			"  .";
		Receive, Empty, EmptyT, Search:
			if (self hasnt open)
				"  .";
	],
  has scenery pluralname ~open;

Object -> officecabinetplates "/ / /"
  class InteriorPlate,
  with
	name '' '' '' '' '',
	short_name "  ",
	work_target officecabinets,
	description "       ,  .",
	before [;
		Take: 
			"   .";
	],
  has ~pluralname female;

Object -> officedesk "/"
  with
	name '' '' '' '',
	description [;
		print " --  ,  ,     . ";
		<<Search self>>;
	],
	vehicle_name " (  )",
	react_before [;
		Exit:
			if (player in self) {
				move player to parent(self);
				if (keep_silent == 0)
					print "   ", (cGen) self, ".^";
				rtrue;
			}
		Go:
			if (player in self && noun == d_obj)
				<<Exit>>;
	],
	before [;
		Push, Pull, Turn:
			print_ret " ", (emphstring) "", " .";
		LookUnder:
			"     ,      .";
		Climb:
			<<Enter self>>;
	],
  has scenery supporter enterable male;

Object -> officebookcase "/ /"
  with
	name '' '' '',
	description "   ,         .       ,   --  ,            .",
	before [;
		Search:
			if (children(self) <= 1)
				"     .";
			print "  ";
			if (children(self) > 1)
				print "";
            else
            	print "";
            print " "; 
			WriteListFrom(child(self),
				TERSE_BIT + ENGLISH_BIT + PARTINV_BIT + CONCEAL_BIT);
			".";
		Receive:
			if (receive_action == ##Insert)
				<<PutOn noun self>>;
		Touch, Rub:
			"       .";
		Push, Pull, Turn:
			"   .";
	],
  has scenery supporter male;

Object officebooks "/" officebookcase
  with
	name '' '' '' '' '' '' '' '' '' ''
		'' '',
	description "     , @<<  @>>,   ...      ,      .     .",
	before [;
		Examine:
			if (verb_word == '' or '')
				"     .";
		Take:
			"        .";
		Push, Pull:
			",         .    .";
		Search:
			<<Search officebookcase>>;
	],
  has pluralname scenery;

Object officeplays "/" SecurityOffice
  with
	name '' '' '' '',
	description [;
		<Examine officebooks>;
		if (self hasnt general) {
			give self general;
			"^(,    -   @<<  @>>.)";
		}
		rtrue;
	],
	before [;
		Take, Search, Push, Pull:
			<<(action) officebooks>>;
	],
  has pluralname scenery; ! general for the in-joke in-joke

Class OfficeSketch
  with
	name '' '' '' '' '' '',
	describe [;
		if (self has static)
			rtrue;
		if (self in SecurityOffice)
			rtrue;
	],
	list_together "",
	description [;
		self.number2();
		if (self hasnt static) {
			print "^    ,        .^";
		}
		rtrue;
	],
	add_to_scope [;
		if (self hasnt static) {
			AddToScope(sketchpad);
		}
	],
	number2 "  , @<<   @>>. []",
	before [;
		Take:
			if (self has static) {
				give self ~static;
				give self general;	
			}
			else {
				give self ~general;
			}
			rfalse;
		PutOn:
			if (second == secofficewalls) {
				if (self has static)
					print_ret (CCNom) self, "    .";
				if (self notin player)
					rfalse;
				move self to SecurityOffice;
				give self static;
				print_ret "  ", (cAcc) self, "  ,    .";
			}
		TouchTo:
			if (second == secofficewalls) {
				<<PutOn self second>>;
			}
	],
	after [;
		Take:
			if (self has general) {
				give self ~general;
				print_ret "  ", (cAcc) self, "  .";
			}
	],
  has static; ! general is used for the take message.

[ OfficeSketchStartup    ix;
	objectloop (ix ofclass OfficeSketch) {
		give ix static;
		move ix to SecurityOffice;
	}
];

[ OfficeSketchNumHanging    res;
	res = (sketch1 has static) + (sketch2 has static) + (sketch3 has static);
	return res;
];

Array sketchlist --> 5;

[ OfficeSketchNumLying   res;
	res = 0;
	if (sketch1 hasnt static && sketch1 in SecurityOffice) 
		sketchlist-->(res++) = sketch1;
	if (sketch2 hasnt static && sketch2 in SecurityOffice) 
		sketchlist-->(res++) = sketch2;
	if (sketch3 hasnt static && sketch3 in SecurityOffice) 
		sketchlist-->(res++) = sketch3;
	return res;
];

Object sketch1 "/ /"
  class OfficeSketch,
  with
	name '' '' '' '' '' '',
	number2 "    ,  .       ,     .",
  has male;

Object sketch2 "///  "
  class OfficeSketch,
  with
	name '' '' '' '' '' '',
    casegen [ beg end csID;
        return ICVowel (csID, beg, end, '', 0);
	],
	number2 "   ,     ,        .      ,   .   ,     .         .",
  has male;

Object sketch3 "/  "
  class OfficeSketch,
  with
	name '' '' '' '' '',
	number2 [;
		print "     ,   .     ,           .";
		if (escaping == 0)
			print "      .";
		else
			print "    ,    ,     ,  ,     ,   .     .";
		new_line;
		rtrue;
	],
  has male;

Object sketchpad "/"
  with
	name '' '',
	description "     .     ,     ,     .",
	before [;
		Take, Pull:
			"   .";
		TouchTo:
			if (second == secofficewalls) {
				<<PutOn self second>>;
			}
	],
  has scenery male;

Object InterrogRoomReal "  ",
  with
	description [;
		print "    ,   .";
		if (interrealchair in self)
			print "      ,";
		else
			print "     ,    ,";
		print "    -- ,  .    .     .";
		new_line;
		rtrue;
	],
	out_to introomdoorway,
	s_to introomdoorway,
	each_turn [;
		if ((~~escaping) && self hasnt general) {
			give self general;
			print_ret "^", (emphstring) "     .";
		}
	],
  has ~general; ! general for each_turn message

Object -> introomdoorway "/"
  class SecurityDoorwayIn,
  with
	name '//' '' '',
	door_dir s_to,
    has male;

Object -> interrealwalls "/"
  with
	name '' '' '',
	description "        .      .",
	before [;
		Touch, Rub, Push, Attack, KnockOn:
			" .";
	],
  has scenery pluralname;

Object -> interrealdesk "/"
  with
	name '',
	description [;
		print "      .       .";
		if (child(self)) {
			print " ";
			<<Search self>>;
		}
		new_line;
		rtrue;
	],
	before [;
		Examine, Search:
			rfalse;
		Climb, Enter:
			"     ,     ,    ,   .";
		LookUnder:
			"   .";
		default:
			if (player in interrealchair)
				"    ,   .";
	],
  has supporter scenery male;

Object -> interrealcontrols "/"
  with
	name '' '' '' '' '' ''
		'' '' '',
	description "  , , ,     .   ,    ,    .",
	before [;
		Examine:
			if (verb_word == '')
				<<Search self>>;
		Search:
			if (player in interrealchair)
				"   ,   .";
			print "    ,   , ,   : @<<@>>, @<<@>>, @<<@>>, @<<. @>>.      .^";
			if ((~~escaping) && self hasnt general) {
				give self general;
				print "^", (emphstring) "    .", "^";
			}
			rtrue;
		SwitchOn, SwitchOff, Push, Pull, Turn:
			<<Touch self>>;
		Touch:
			if (player in interrealchair)
				"    ,   .";
			if (escaping)
				"       .";
			print "   .  - ,     .^";
			EndScene(9);
			rtrue;
		Take:
			"   .";
	],
  has pluralname scenery ~general; ! general for Search extra message.

Object -> interrealpedestal "/ /"
  with
	name '' '' '' '',
	description "    ,  .     .",
	before [ fn;
		Examine:
			if (~~escaping) {
				if (self hasnt general) {
					give self general;
					fn = emphstring;
				}
				else {
					fn = normstring;
				}
				fn("    .");
				new_line;
				rtrue;
			}
		Search:
			<<Examine self>>;
	],
  has scenery neuter; ! general means italic warning

! the chair will be gone when escaping starts, so we don't need to
! check escaping in here.
Object -> interrealchair "/"
  with
	name '' '' '' '' '' '' '',
	description " .       ,       ,     . ,     ,  . ,    ,   .",
	vehicle_name " ( )",
	vehicle_status_name ",  ",
	react_before [ ix;
		Exit:
			if (player in self) {
				move player to parent(self);
				switch (self.number) {
					0, -1:
						print " .^";
					1, 2:
						print "  .^";
					default:
						print "   ,   ,      .";
						if (self.number >= 6)
							print "^^  .";
						new_line;
				}
				rtrue;
			}
		Listen:
			if (player in self && self.number >= 6) {
				if (second == nothing) {
					return RunRoutines(ghostman, before); ! icky
				}
			}
		Yes, No:
			if (player in self && self.number >= 6) {
				<<Answer self ghostman>>;
			}
		Wait:
			if (player in self && self.number >= 6) {
				"  .";
			}
		VagueSay:
			if (player in self && self.number >= 6) {
				! allow keywords to fall through so that a device can react_before
				if (consult_words >= 1) {
					wn = consult_from;
					ix = NextWord();
					if (ix == '~//' && consult_words >= 2) {
						ix = NextWord();
					}
					if (ix == 'tango') {
						rfalse;
					}
					if (ix == 'waltz') {
						rfalse;
					}
				}
				<<Answer noun ghostman>>;
			}
		Wake, Sleep:
			if (player in self && self.number > 0) {
				"  , .";
			}
	],
	before [;
		LookUnder:
			<<Examine interrealpedestal>>;
		Touch, Rub:
			"     .";
		Push, Pull, Turn:
			"     .";
	],
	after [;
		Enter:
			! reset ghost counter, unless it's over.
			if (self.number > 0)
				self.number = 0; 
			"   .  .";
	],
	number 0,
	add_to_scope [;
		if (player in self && self.number >= 6)
			AddToScope(ghostman);
	],
	each_turn [;
		if (player in self) {
			if (self.number < 0)
				return;
			self.number++;
			switch (self.number) {
				1: print "^", (emphstring) "    .", "^";
				3: print "^", (emphstring) "        ,    .", "^";
				6: print "^", (emphstring) "   -,      .", "^";
				8: print "^", (emphstring) "           .      .", "^";
				10:
					print "^", (emphstring) "      - --", "^^ .     .^";
					self.number = -1;
			}
		}
	],
  has scenery enterable supporter neuter;

Object -> interrealbands "/"
  with
	name '' '' '' '' '' '' '' '',
	description [;
		if (player in interrealchair && interrealchair.number >= 3)
			"     ,   ,       .";
		"     .";
	],
	before [;
		Take:
			" .";
		Touch, Rub:
			"     .";
		Attack:
			"   .";
		Wear, Enter:
			"  .";
		TouchTo:
			if (second == player)
				<<Wear self>>;
	],
  has scenery pluralname;

Object -> interrealleads "//"
  with
	name '' '' '' '',
	description ",   ,  .        .",
	before [;
		Take:
			"   .";
		Attack, Pull:
			"  .";
		Wear:
			"  .";
		TouchTo:
			if (second == player)
				<<Wear self>>;
		TouchFrom:
			if (noun == player)
				<<Wear self>>;
	],
  has scenery pluralname;

Object ghostman "/"
  with
	name '' 'interrogator' '' '' '',
	description [;
		print "    --       ,     .      --     ,  .^";
	],
	before [;
		Examine:
			rfalse;
		Listen:
			"   ,    -   .";
		Ask, Tell:
			"    .";
		ThrownAt:
			" ,   .";
		default:
			"   ,    .";
	],
	life [;
		Ask, Tell, Answer:
			"    .";
	],
	orders [;
		"    .";
	],
  has scenery animate male;

Object SecurityStorage "  ",
  with
	description [;
		print "     .      ,      .";
		if (storelockers hasnt open)
			"   .";
		else
			"    .";
	],
	out_to secstoredoorway,
	n_to secstoredoorway;

Object -> secstoredoorway "/"
  class SecurityDoorwayIn,
  with
	name '//' '' '',
	door_dir n_to,
    has male;

Object -> storelockers "/"
  with
	name '' '' '',
	description [;
		print "      ,         ,  , ,     .";
		if (self hasnt open)
			"   ,       4- .";
		else 
			print_ret "     ,   ", self.number, ",  .";
	],
	number 0,
	before [;
		Open:
			"   .";
		Close:
			if (self hasnt open)
				"   .";
		Receive, Empty, EmptyT, Search, Enter:
			if (self hasnt open)
				"  .";
		Attack, KnockOn:
			"     ,      .";
	],
  has scenery pluralname;

Object -> storelockernumbers "/ "
  with
	name '' '' '',
	description [;
		print_ret "     .     ",
			1000 + random(8999), ".";
	],
	before [;
		Take:
			"    .";
	],
  has scenery pluralname;

Object -> storetable "/"
  with
	name '' '' '' '',
	description [;
		print "      ,    . ";
		<<Search self>>;
	],
	before [;
		Enter, Climb:
			"    ,    .";
		Push, Pull, Turn:
			"   ,    .   .";
		LookUnder:
			"   .";
	],
  has scenery supporter male;

Object poisonpen "/"
  with
	name '',
	description [;
		print "   ";
		if (pennib in self)
			print ".    ";
		else
			print ".  ";
		if (penstain in self) 
			print "     ";
		".";
	],
	before [;
		TouchTo:
			if (pennib in self)
				<<ActivateTool pennib second>>;
		WriteWith:
			if (pennib in self)
				<<ActivateTool pennib second>>;
			if (second == labconoval)
				<<BaseTouchTo self second>>;
			"     .";
	],
  has transparent female;

Object pennib "///"
  with
	name '' '' '' '' '' '' '' '' '',
	description "  --   . ,    -   ,     .",
    casegen [ beg end csID;
        return ICVowel (csID, beg, end, '', 0);
	],
	react_before [;
		AttackWith:
			if (second == self or poisonpen) {
				<<ActivateTool self noun>>;
			}
	],
	before [;
		ActivateTool:
			if (self notin poisonpen)
				"  , . []";
			if (poisonpen notin player)
				"     .";
			if (second == self or poisonpen)
				" ,   .";
			if (second == player)
				<<Touch self>>;
			if (second == loneguard) {
				remove self;
				move penstain to poisonpen;
				<<ActivateTool loneguard>>;
			}
			remove self;
			print_ret "    ", (cAcc) second, "  .";
		TouchTo:
			<<ActivateTool self second>>;
		Attack, Push, Pull:
			remove self;
			"     ,       .";
		Touch:
			print "      ,   .  ,        ,    .     .^";
			remove self;
			EndScene(-4);
			rtrue;
		Taste:
			print "       ,   .        ,   ,      .^";
			remove self;
			EndScene(-4);
			rtrue;
	],
  has scenery male;

Object penstain "/ "
  with
	name '' '' '',
	description "      .",
	before [;
		Take, Rub:
			remove self;
			"   ,    .";
	],
  has scenery male;

Constant MAX_BLIPS 8;
Array blipfrom --> 9; ! MAX_BLIPS+1
Array blipto   --> 9; ! MAX_BLIPS+1

#ifdef ZDEBUG;

[ DebugBlip    ix;
	print "", securityscanners.blips, " .^";
	for (ix = 0 : ix < securityscanners.blips && ix < MAX_BLIPS : ix++) {
		print ix, ": ", (name) blipfrom-->ix, "  ", 
			(name) blipto-->ix, "^";
	}
	if (blipfrom-->MAX_BLIPS ~= -7 || blipto-->MAX_BLIPS ~= -7)
		print "   ! (", (blipfrom-->MAX_BLIPS), ", ",
			(blipto-->MAX_BLIPS), ")^";
];

#endif;

Object securityscanners
  with
	startup [;
		self.number = 0;
		self.scramble_counter = 0;
		self.blips = 0;
		blipfrom-->MAX_BLIPS = -7;
		blipto-->MAX_BLIPS = -7;
		StartDaemon(self);
		StartDaemon(securityfriers);
	],
	shutdown [;
		StopDaemon(self);
		StopDaemon(securityfriers);
	],
	daemon_priority -20, ! very low; occurs after tools.
	number 0, ! set to nonzero to trigger a threshold alarm.
	scramble_counter 0,
	blips 0,
	daemon [;
		if (player == passiveplayer) {
			self.shutdown();
			"   ,   . []";
		}
		! the scrambler has just fried, then the timer has ticked, now this.
		switch (self.number) {
			1:
				print "^  ,            .^";
				EndScene(1, 1);
				return;
			2:
				print "^  ,            .^";
				EndScene(1, 2);
				return;
		}
		if (scrambler has general && scrambler.fried == 0) {
			if (self.scramble_counter == 0) {
				! just switched on
				if (self.blips < MAX_BLIPS) {
					blipfrom-->(self.blips) = location;
				}
			}
			else {
				! continuing on
			}
			
			self.scramble_counter++;
			if (self.scramble_counter == 1
				&& scrambler.work_target == timerswitch) {
				! no advantage if the thing turns itself off!
				self.scramble_counter++; 
			}
			if (self.scramble_counter >= 3) {
				print "^     .      ,    .^";
				EndScene(2);
				return;
			}
		}
		else {
			! the scrambler is off.
			if (self.scramble_counter) {
				self.scramble_counter = 0;
				if (self.blips < MAX_BLIPS) {
					blipto-->(self.blips) = location;
				}
				self.blips++;
			}
		}
	];

Object securityfriers
  with
	daemon_priority -2, ! before tools
	daemon [;
		if (scrambler has general && scrambler.fried == 0) {
			if (ScramblerPos() == 2) {
				scrambler.fried = true;
				print "^     ,        ,   ,       .^";
			}
		}
	];
	
[ TryLeaveSecurity    num ix didoffice didstore didinter;
	
	wastehall = 0;
	wasteroom = 0;
	
	if (scrambler.fried)
		print " ! []^";

	if (scrambler has general) {
		EndScene(5);
		return;
	}
	
	if (anywherein(poisonpen, player) == 0) {
		EndScene(7, 1);
		return;
	}
	if (pennib notin poisonpen) {
		EndScene(7, 2);
		return;
	}
	
	num = securityscanners.blips;
	
	didoffice = 0;
	didstore = 0;
	didinter = 0;
	
	for (ix=0 : ix<num && ix<MAX_BLIPS : ix++) {

		switch (blipfrom-->ix) {
			SecurityOffice: didoffice = 1;
			SecurityStorage: didstore = 1;
			InterrogRoomReal: didinter = 1;
		}
		switch (blipto-->ix) {
			SecurityOffice: didoffice = 1;
			SecurityStorage: didstore = 1;
			InterrogRoomReal: didinter = 1;
		}
		
		if (blipto-->ix == blipfrom-->ix) {
			if (blipto-->ix == SecurityAnnex)
				wastehall++;
			else
				wasteroom++;
		}
		else {
			if (blipto-->ix ~= SecurityAnnex && blipfrom-->ix ~= SecurityAnnex)
				"  . []";
		}
	}
	
	if (num ~= 4) {
		EndScene(3, num);
		return;
	}
	
	if (didoffice + didstore + didinter >= 3) {
		"     ? []";
	}
	
	if (didoffice + didstore + didinter <= 1) {
		ix = 0;
		if (didoffice) ix = SecurityOffice;
		if (didstore) ix = SecurityStorage;
		if (didinter) ix = InterrogRoomReal;
		EndScene(4, ix);
		return;
	}
	
	if (didinter) {
		EndScene(6);
		return;
	}
	
	ix = LeftToolsBehind(5);
	if (ix) {
		EndScene(8, ix);
		rtrue;
	}

	! So now we know there were 4 blips, two rooms entered, and not the interrog
	! room. That's all we need, right?
	
	EndScene(20);
	rtrue;
];

